package uk.co.his.test.ssb4;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.annotation.Resource;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.jws.HandlerChain;
import javax.jws.WebService;
import javax.transaction.Status;
import javax.transaction.SystemException;
import javax.transaction.TransactionManager;

/**
 * Session Bean implementation class SSB2
 */
@Stateless
@LocalBean
@WebService
@HandlerChain(file = "/context-handlers.xml")
public class SSB4 implements SSB4Remote {

	@Resource(lookup = "java:jboss/TransactionManager")
	private TransactionManager txManager;

	@Resource(lookup="java:/MSSQLDSXA")
	private javax.sql.DataSource theDB;

	/**
	 * Default constructor.
	 */
	public SSB4() {
		// TODO Auto-generated constructor stub
	}

	private static String getTxStatus(int status) {
		switch (status) {
		case Status.STATUS_ACTIVE:
			return "Active";
		case Status.STATUS_COMMITTED:
			return "Committed";
		case Status.STATUS_COMMITTING:
			return "Committing";
		case Status.STATUS_MARKED_ROLLBACK:
			return "Marked for rollback";
		case Status.STATUS_NO_TRANSACTION:
			return "No Transaction";
		case Status.STATUS_PREPARED:
			return "Prepared";
		case Status.STATUS_PREPARING:
			return "Preparing";
		case Status.STATUS_ROLLEDBACK:
			return "Rolledback";
		case Status.STATUS_ROLLING_BACK:
			return "Rollingback";
		case Status.STATUS_UNKNOWN:
			return "Status set to STATUS_UNKNOWN";
		}
		return "Unknown Status " + status;
	}

	private String getTxName() {
		try {
			if (txManager == null) {
				return "No Transaction Manager";
			} else {
				if (txManager.getTransaction() == null) {
					return "No Transaction";
				} else {
					return "A Transaction: status="
							+ getTxStatus(txManager.getTransaction()
									.getStatus()) + ". {Transaction: "
							+ txManager.getTransaction() + "}";
				}
			}
		} catch (SystemException e) {
			return "Error getting TxName: " + e;
		}
	}

	private String getDsName() {
		try {
			if (theDB == null) {
				return "No DataSource";
			} else {
				return theDB.toString();
			}
		} finally {
		}
	}

	@Override
	public String hello(String tag) {
		return tag + " you!\n\tClass: " + getClass().getName()
				+ "\n\tDataSource: " + getDsName() + "\n\tTxName: "
				+ getTxName();
	}

	@Override
	public int add(String tag, int val) throws AppException4 {
		try {
			Connection c = null;
			Statement s = null;
			ResultSet r = null;
			int lastValue;
			try {
				c = theDB.getConnection();
				s = c.createStatement();
				r = s.executeQuery("SELECT Val from TAGGEDINTEGERVALUE WHERE (TAG = '"
						+ tag + "')");
				lastValue = 0;
				if (r == null || !r.next()) {
					int result = s
							.executeUpdate("INSERT INTO TAGGEDINTEGERVALUE VALUES ('"
									+ tag + "', " + lastValue + ")");
					if (result != 1) {
						throw new SQLException(
								"Cannot insert TAGGEDINTEGERVALUE row with index "
										+ tag);
					}
				} else {
					lastValue = r.getInt(1);
					r.close();
					r = null;
				}
				int result = s
						.executeUpdate("UPDATE TAGGEDINTEGERVALUE set Val = "
								+ (lastValue + val) + " WHERE (TAG = '" + tag
								+ "')");
				if (result != 1) {
					throw new SQLException(
							"Cannot insert TAGGEDINTEGERVALUE row with index "
									+ tag);
				}
			} finally {
				try {
					if (r != null)
						r.close();
				} catch (Exception e) {
					e.printStackTrace();
				}
				try {
					if (s != null)
						s.close();
				} catch (Exception e) {
					e.printStackTrace();
				}
				try {
					if (c != null)
						c.close();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			s.close();
			c.close();
			return lastValue + val;
		} catch (SQLException e) {
			throw new AppException4(e);
		}
	}

}
